"use client";
import React, { useEffect, useRef, useState } from "react";
import { useForm, Controller } from "react-hook-form";
import { Input } from "@/components/ui/input";
import { Button } from "@/components/ui/button";
import { Label } from "@/components/ui/label";
import { Card } from "@/components/ui/card";
import { zodResolver } from "@hookform/resolvers/zod";
import * as z from "zod";
import Swal from "sweetalert2";
import withReactContent from "sweetalert2-react-content";
import { useParams, useRouter } from "next/navigation";
import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue,
} from "@/components/ui/select";
import { Checkbox } from "@/components/ui/checkbox";
import { RadioGroup, RadioGroupItem } from "@/components/ui/radio-group";
import JoditEditor from "jodit-react";
import { createTask, getUserLevelForAssignments } from "@/service/task";
import { cn } from "@/lib/utils";
import { format } from "date-fns";
import { CalendarIcon, ChevronDown, ChevronUp } from "lucide-react";
import { id } from "date-fns/locale";
import { getPlanningById, publishPlanning } from "@/service/planning/planning";
import {
  Dialog,
  DialogContent,
  DialogDescription,
  DialogFooter,
  DialogHeader,
  DialogTitle,
  DialogTrigger,
} from "@/components/ui/dialog";
import { AlertDialogHeader } from "@/components/ui/alert-dialog";
import { Description } from "@radix-ui/react-toast";

const taskSchema = z.object({
  title: z.string().min(1, { message: "Judul diperlukan" }),
  description: z.string().min(2, {
    message: "Narasi Penugasan harus lebih dari 2 karakter.",
  }),
});

export type mediahubDetail = {
  id: number;
  title: string;
  name: string;
  fileTypeOutput: string;
  assignedToTopLevel: string;
  assignedToLevel: string;
  assignmentType: {
    id: number;
    name: string;
  };
  date: string;
  description: string;
  is_active: string;
};

export default function PublishMediahub() {
  const MySwal = withReactContent(Swal);
  const router = useRouter();
  const editor = useRef(null);
  type TaskSchema = z.infer<typeof taskSchema>;
  const { id } = useParams() as { id: string };
  console.log(id);
  const [taskOutput, setTaskOutput] = useState({
    all: false,
    video: false,
    audio: false,
    image: false,
    text: false,
  });
  const [mainType, setMainType] = useState<number>(1);
  const [taskType, setTaskType] = useState<string>("atensi-khusus");
  const [broadcastType, setBroadcastType] = useState<string>("all"); // untuk Tipe Penugasan
  const [type, setType] = useState<string>("1");
  const [selectedTarget, setSelectedTarget] = useState("all");
  const [startDate, setStartDate] = useState<Date>(new Date());
  const [detail, setDetail] = useState<mediahubDetail>();
  const [refresh] = useState(false);
  const [listDest, setListDest] = useState([]); // Data Polda dan Polres
  const [checkedLevels, setCheckedLevels] = useState(new Set());
  const [expandedPolda, setExpandedPolda] = useState([{}]);
  const [isLoading, setIsLoading] = useState(false);

  const [platformTypeVisible, setPlatformTypeVisible] = useState(false);
  const [unitSelection, setUnitSelection] = useState({
    allUnit: false,
    mabes: false,
    polda: false,
    polres: false,
  });

  const {
    control,
    handleSubmit,
    formState: { errors },
  } = useForm<TaskSchema>({
    resolver: zodResolver(taskSchema),
  });

  const handleRadioChange = (event: React.ChangeEvent<HTMLInputElement>) => {
    const selectedValue = Number(event.target.value);
    setMainType(selectedValue);

    setPlatformTypeVisible(selectedValue === 2);
  };
  useEffect(() => {
    async function fetchPoldaPolres() {
      setIsLoading(true);
      try {
        const response = await getUserLevelForAssignments();
        setListDest(response?.data?.data.list);
        const initialExpandedState = response?.data?.data.list.reduce(
          (acc: any, polda: any) => {
            acc[polda.id] = false;
            return acc;
          },
          {}
        );
        setExpandedPolda(initialExpandedState);
        console.log("polres", initialExpandedState);
      } catch (error) {
        console.error("Error fetching Polda/Polres data:", error);
      } finally {
        setIsLoading(false);
      }
    }
    fetchPoldaPolres();
  }, []);

  useEffect(() => {
    async function initState() {
      if (id) {
        const response = await getPlanningById(id);
        const details = response?.data?.data;

        setDetail(details);
        if (details?.date) {
          setStartDate(new Date(details.date));
        }

        if (details?.assignedToLevel) {
          const levels = new Set(
            details.assignedToLevel.split(",").map(Number)
          );
          setCheckedLevels(levels);
        }
      }
    }
    initState();
  }, [id, refresh]);

  useEffect(() => {
    if (detail?.fileTypeOutput) {
      const outputSet = new Set(detail.fileTypeOutput.split(",").map(Number));
      setTaskOutput({
        all: outputSet.has(0),
        video: outputSet.has(2),
        audio: outputSet.has(4),
        image: outputSet.has(1),
        text: outputSet.has(3),
      });
    }
  }, [detail?.fileTypeOutput]);

  useEffect(() => {
    if (detail?.assignedToTopLevel) {
      const outputSet = new Set(
        detail.assignedToTopLevel.split(",").map(Number)
      );
      setUnitSelection({
        allUnit: outputSet.has(0),
        mabes: outputSet.has(1),
        polda: outputSet.has(2),
        polres: outputSet.has(3),
      });
    }
  }, [detail?.fileTypeOutput]);

  const handleCheckboxChange = (levelId: number) => {
    setCheckedLevels((prev) => {
      const updatedLevels = new Set(prev);
      if (updatedLevels.has(levelId)) {
        updatedLevels.delete(levelId);
      } else {
        updatedLevels.add(levelId);
      }
      return updatedLevels;
    });
  };

  const handlePoldaPolresChange = () => {
    return Array.from(checkedLevels).join(","); // Mengonversi Set ke string
  };

  const save = async (data: TaskSchema) => {
    const fileTypeMapping = {
      all: "1",
      video: "2",
      audio: "3",
      image: "4",
      text: "5",
    };

    const unitMapping = {
      allUnit: "0",
      mabes: "1",
      polda: "2",
      polres: "3",
    };
    const assignmentPurposeString = Object.keys(unitSelection)
      .filter((key) => unitSelection[key as keyof typeof unitSelection])
      .map((key) => unitMapping[key as keyof typeof unitMapping])
      .join(",");

    const selectedOutputs = Object.keys(taskOutput)
      .filter((key) => taskOutput[key as keyof typeof taskOutput])
      .map((key) => fileTypeMapping[key as keyof typeof fileTypeMapping])
      .join(",");

    const requestData: {
      id?: number;
      title: string;
      target: string;
      assignedToLevel: any;
      assignmentPurpose: any;
      assignmentTypeId: string;
      fileTypeOutput: string;
      description: string;
      platformType: string | null;
      date: any;
      assignmentMainTypeId: number;
      planningTypeId: number;
      time: string;
    } = {
      ...data,
      // assignmentType,
      // assignmentCategory,
      target: selectedTarget,
      assignedToLevel: handlePoldaPolresChange(),
      assignmentPurpose: assignmentPurposeString,
      assignmentTypeId: type,
      fileTypeOutput: selectedOutputs,
      description: data.description,
      platformType: "",
      title: data.title,
      date: startDate,
      planningTypeId: 1,
      time: "1",
      assignmentMainTypeId: 1,
    };

    if (id) {
      requestData.id = parseInt(id, 10); // Ensure id is a number
    }

    console.log("Form Data Submitted:", requestData);

    const response = await publishPlanning(requestData);

    console.log("Form Data Submitted:", requestData);
    console.log("response", response);

    MySwal.fire({
      title: "Sukses",
      text: "Data berhasil disimpan.",
      icon: "success",
      confirmButtonColor: "#3085d6",
      confirmButtonText: "OK",
    }).then(() => {
      router.push("/en/contributor/planning/mediahub");
    });
  };

  const onSubmit = (data: TaskSchema) => {
    MySwal.fire({
      title: "Simpan Data",
      text: "Apakah Anda yakin ingin menyimpan data ini?",
      icon: "warning",
      showCancelButton: true,
      cancelButtonColor: "#d33",
      confirmButtonColor: "#3085d6",
      confirmButtonText: "Simpan",
    }).then((result) => {
      if (result.isConfirmed) {
        save(data);
      }
    });
  };

  const toggleExpand = (poldaId: any) => {
    setExpandedPolda((prev: any) => ({
      ...prev,
      [poldaId]: !prev[poldaId],
    }));
  };

  return (
    <Card>
      <div className="px-6 py-6">
        <p className="text-lg font-semibold mb-3">Perencanaan Mediahub</p>
        {detail !== undefined ? (
          <form onSubmit={handleSubmit(onSubmit)}>
            <div className="gap-5 mb-5">
              {/* Input Title */}
              <div className="space-y-2">
                <Label>Judul</Label>
                <Controller
                  control={control}
                  name="title"
                  render={({ field }) => (
                    <Input
                      size="md"
                      type="text"
                      defaultValue={detail?.title}
                      onChange={field.onChange}
                      placeholder="Enter Title"
                    />
                  )}
                />
                {errors.title?.message && (
                  <p className="text-red-400 text-sm">{errors.title.message}</p>
                )}
              </div>
              <div className="mt-6">
                <Label>Output Tugas</Label>
                <div className="flex flex-wrap gap-3 mt-1">
                  {Object.keys(taskOutput).map((key) => (
                    <div className="flex items-center gap-2" key={key}>
                      <Checkbox
                        id={key}
                        checked={taskOutput[key as keyof typeof taskOutput]}
                        onCheckedChange={(value) =>
                          setTaskOutput({ ...taskOutput, [key]: value })
                        }
                      />
                      <Label htmlFor={key}>
                        {key.charAt(0).toUpperCase() + key.slice(1)}
                      </Label>
                    </div>
                  ))}
                </div>
              </div>
              <div className="mt-6">
                <Label>Pelaksana Tugas</Label>
              </div>
              <div className="flex flex-row items-center gap-3">
                <div className="">
                  <div className="flex flex-wrap gap-2">
                    {Object.keys(unitSelection).map((key) => (
                      <div className="flex items-center gap-2" key={key}>
                        <Checkbox
                          id={key}
                          checked={
                            unitSelection[key as keyof typeof unitSelection]
                          }
                          onCheckedChange={(value) =>
                            setUnitSelection({ ...unitSelection, [key]: value })
                          }
                        />
                        <Label htmlFor={key}>
                          {key.charAt(0).toUpperCase() + key.slice(1)}
                        </Label>
                      </div>
                    ))}
                  </div>
                </div>
                <Dialog>
                  <DialogTrigger asChild>
                    <Button variant="soft" size="sm" color="primary">
                      [Kustom]
                    </Button>
                  </DialogTrigger>
                  <DialogContent className="sm:max-w-[425px] md:max-w-[500px] lg:max-w-[1500px]">
                    <DialogHeader>
                      <DialogTitle>Daftar Wilayah Polda dan Polres</DialogTitle>
                    </DialogHeader>
                    <div className="grid grid-cols-2 gap-2 max-h-[400px] overflow-y-auto">
                      {listDest.map((polda: any) => (
                        <div key={polda.id} className="border p-2">
                          <Label className="flex items-center">
                            <Checkbox
                              checked={checkedLevels.has(polda.id)}
                              onCheckedChange={() =>
                                handleCheckboxChange(polda.id)
                              }
                              className="mr-3"
                            />
                            {polda.name}
                            <button
                              onClick={() => toggleExpand(polda.id)}
                              className="ml-2 focus:outline-none"
                            >
                              {expandedPolda[polda.id] ? (
                                <ChevronUp size={16} />
                              ) : (
                                <ChevronDown size={16} />
                              )}
                            </button>
                          </Label>
                          {expandedPolda[polda.id] && (
                            <div className="ml-6 mt-2">
                              <Label className="block">
                                <Checkbox
                                  checked={polda?.subDestination?.every(
                                    (polres: any) =>
                                      checkedLevels.has(polres.id)
                                  )}
                                  onCheckedChange={(isChecked) => {
                                    const updatedLevels = new Set(
                                      checkedLevels
                                    );
                                    polda?.subDestination?.forEach(
                                      (polres: any) => {
                                        if (isChecked) {
                                          updatedLevels.add(polres.id);
                                        } else {
                                          updatedLevels.delete(polres.id);
                                        }
                                      }
                                    );
                                    setCheckedLevels(updatedLevels);
                                  }}
                                  className="mr-2"
                                />
                                Pilih Semua Polres
                              </Label>
                              {polda?.subDestination?.map((polres: any) => (
                                <Label key={polres.id} className="block mt-1">
                                  <Checkbox
                                    checked={checkedLevels.has(polres.id)}
                                    onCheckedChange={() =>
                                      handleCheckboxChange(polres.id)
                                    }
                                    className="mr-2"
                                  />
                                  {polres.name}
                                </Label>
                              ))}
                            </div>
                          )}
                        </div>
                      ))}
                    </div>
                  </DialogContent>
                </Dialog>
              </div>
              <div className="mt-6">
                <Label>Jenis Penugasan</Label>
                <RadioGroup
                  value={detail?.assignmentType?.id.toString()}
                  onValueChange={(value) => setType(value)}
                  className="flex flex-wrap gap-3"
                >
                  <div className="flex items-center gap-2">
                    <RadioGroupItem value="1" id="publication" />
                    <Label htmlFor="publication">Publikasi</Label>
                  </div>
                  <div className="flex items-center gap-2">
                    <RadioGroupItem value="2" id="amplification" />
                    <Label htmlFor="amplification">Amplifikasi</Label>
                  </div>
                  <div className="flex items-center gap-2">
                    <RadioGroupItem value="3" id="contra" />
                    <Label htmlFor="contra">Kontra</Label>
                  </div>
                </RadioGroup>
              </div>
              <div className="mt-6">
                <div className="flex flex-col">
                  <Label>Date</Label>
                  <div>
                    <Button
                      defaultValue={detail?.date}
                      variant="outline"
                      size="md"
                      className={cn(
                        " justify-between text-left font-normal border-default-200 text-default-600 md:px-4 w-3/12",
                        !startDate && "text-muted-foreground"
                      )}
                    >
                      {startDate ? (
                        format(startDate, "PP")
                      ) : (
                        <span>Pick a date</span>
                      )}
                      <CalendarIcon className="h-4 w-4" />
                    </Button>
                  </div>
                </div>
              </div>
              <div className="mt-6">
                <Label>Narasi Penugasan</Label>
                <Controller
                  control={control}
                  name="description"
                  render={({ field: { onChange, value } }) => (
                    <JoditEditor
                      ref={editor}
                      value={detail?.description}
                      onChange={onChange}
                      className="dark:text-black"
                    />
                  )}
                />
                {errors.description?.message && (
                  <p className="text-red-400 text-sm">
                    {errors.description.message}
                  </p>
                )}
              </div>
            </div>

            {/* Submit Button */}
            <div className="mt-4">
              <Button type="submit" color="primary">
                Submit
              </Button>
            </div>
          </form>
        ) : (
          ""
        )}
      </div>
    </Card>
  );
}
